﻿public class FreeVendingMachines : Mod
{
    private HarmonyLib.Harmony harmony;
    private static string modId = "com.raftmodding.mods.free-vending-machines";
    public void Start()
    {
        harmony = new HarmonyLib.Harmony(modId);
        harmony.PatchAll();
    }
    public void OnModUnload()
    {
        harmony.UnpatchAll(modId);
    }
    [HarmonyLib.HarmonyPatch(typeof(VendingMachine_Element), "HasInteractRequirement", new System.Type[] { typeof(Network_Player) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.High)]
    public class HarmonyPatch_VendingMachineElement_HasInteractRequirement
    {
        static bool Prefix(ref bool __result, ref Network_Player player)
        {
            __result = true;
            return false;
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(VendingMachine_Element), "ConsumeRequiredItems", new System.Type[] { typeof(Network_Player), typeof(QuestItemManager) })]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_VendingMachineElement_ConsumeRequiredItems
    {
        static void Prefix(ref QuestEventBase.InteractRequirementItem ___interactRequirement, ref Network_Player player, ref QuestItemManager questItemManager)
        {
            if (___interactRequirement.questItem?.DisplayTerm == "QuestItem/Tangaroa_Token")
            {
                ___interactRequirement.amount = 0;
            }
        }
    }
}
